; A LAML mode used to distinguish LAML buffers from other buffers.

; The LAML library and programs written by Kurt Normark, Aalborg University, Denmark.
; Copyright (C) 1999-2002  Kurt Normark, normark@cs.auc.dk.
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


(define-derived-mode 
	laml-mode scheme-mode "Laml" 
  "A LAML Emacs mode mode, which binds some keys (see below) to a useful LAML meaning. 
LAML means 'Lisp Abstracted Markup Language'. LAML makes HTML and XML languages available as 
Scheme functions. 

The general LAML key bindings are defined in the file emacs-support/laml-key-menu-bindings.el
of your LAML distribution.

Used in hygienic mode, the most important LAML mode key bindings are

 C-c C-o       Asynchronous LAML processing
 C-c C-x C-o   Synchronous LAML processing
 C-c C-x C-e   Embeding of selected string in a Scheme function and accompanying string splitting.
 C-c C-r       Unembed - opposite command of embed.
 C-c C-q       Split string.
 C-c C-a       Unsplit string - opposite command of split.
 C-c C-n       Nest form.
 C-x C-m       Unnest form -  opposite command of nest.

Using in original mode, the bindings are

 C-o           Asynchronous LAML processing
 C-x C-o       Synchronous LAML processing
 C-x C-e       Embeding of selected string in a Scheme function and accompanying string splitting.
 C-x C-r       Unembed - opposite command of embed.
 C-x C-q       Split string.
 C-x C-a       Unsplit string - opposite command of split.
 C-x C-n       Nest form.
 C-x C-m       Unnest form -  opposite command of nest.

The choice between hygienic and original mode is made at LAML installation time, in the 
file laml-config/configuration.

You should notice the Laml menu in Emacs, which is available in LAML mode.
Also notice Tools > Laml menu, which is always present.

Laml mode is derived from Scheme mode, and Scheme font locking is in effect.

Use M-x laml-customize to customize LAML mode. 

Runs laml-mode-hook for extension purposes."

  (font-lock-mode t)

)

